package JoelCastellanosAnimations;

//import JoelCastellanosAnimations.Animation;

import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.image.PixelWriter;
import javafx.scene.paint.Color;

import java.util.Random;

public class DLA_MosesGuillermoCampbellSantos extends Animation
{
  private static final int[] dx = {1, 0, -1, 0};
  private static final int[] dy = {0, 1, 0, -1};
  private static final double size = 40;
  private static final Color background = Color.rgb(0, 0, 0);
  int[][] grid = new int[DRAW_WIDTH+10][DRAW_HEIGHT+10];
  private Canvas canvas;
  private int PARTICLES = 20000;
  private GraphicsContext gtx;
  private Point[] pointlist = new Point[PARTICLES];
  private int delta;
  private int direction;
  private int step;
  private Random random = new Random();
  private int centerX, centerY, bottomY;
  private int[] bottomX = new int[PARTICLES];
  private int limit = 200;
  private int paletteIdx = 0;
  private PixelWriter pixelWriter;

  public DLA_MosesGuillermoCampbellSantos(Canvas canvas)
  {
    this.canvas = canvas;
    gtx = canvas.getGraphicsContext2D();

    step = 0;
    delta = 5;
    direction = 0;
    centerX = DRAW_WIDTH / 2;
    centerY = DRAW_HEIGHT / 2;
    bottomY = DRAW_HEIGHT;
    Random rando = new Random();
    //bottomX = rando.nextInt(DRAW_WIDTH) + 1;


    for (int i = 0; i < PARTICLES; i++)
    {
      bottomX[i] = rando.nextInt(DRAW_WIDTH) + 1;
      pointlist[i] = new Point(bottomX[i], bottomY);
    }

    //point.x = DRAW_WIDTH / 2;
    //point.y = DRAW_HEIGHT / 2;

    restart();

    gtx.setLineWidth(3);

    gtx.setFill(background);
    gtx.fillRect(0, 0, DRAW_WIDTH, DRAW_HEIGHT);

    pixelWriter = canvas.getGraphicsContext2D().getPixelWriter();


    for (int i = 0; i < PARTICLES; i++)
    {
      pointlist[i].x = bottomX[i];
      pointlist[i].y = bottomY;
    }


    gtx.setStroke(Color.RED);
    gtx.strokeOval(centerX - 0.5, centerY - 0.5, 0.5, 0.5);
    gtx.setStroke(Color.WHITE);
  }


  public void handle(long now)
  {

    for (int i = 0; i < 10; i++)
    {
      step++;
      //gtx.fillOval(x - size / 2, y - size / 2, size, size);
      //gtx.strokeOval(x - size / 2, y - size / 2, size, size);
      //gtx.setFill(background);
      //gtx.fillRect(0, 0, DRAW_WIDTH, DRAW_HEIGHT);
      for (int k = 0; k < PARTICLES; k++)
      {


        pixelWriter.setColor(pointlist[k].x, pointlist[k].y, Color.rgb(0, 0, 0));


        int dx = bottomX[k] - pointlist[k].x;
        int dy = bottomY - pointlist[k].y;

        if (pointlist[k].x <= 0 || pointlist[k].y <= 0)
        {
          pointlist[k].x = bottomX[k];
          pointlist[k].y = bottomY;
        } else if (pointlist[k].x >= DRAW_WIDTH || pointlist[k].y >= DRAW_HEIGHT)
        {
          pointlist[k].x = bottomX[k];
          pointlist[k].y = bottomY;
        }
        if (grid[pointlist[k].x + 1][pointlist[k].y] != 0)
        {
          System.out.println(step);
          //System.out.println("x= " + pointlist[k].x + ", y= " + pointlist[k].y);
          grid[pointlist[k].x][pointlist[k].y] = 1;
          drawCrystal();
          pointlist[k].x = bottomX[k];
          pointlist[k].y = bottomY;
        } else if (grid[pointlist[k].x - 1][pointlist[k].y] != 0)
        {
          System.out.println(step);
          //System.out.println("x= " + pointlist[k].x + ", y= " + pointlist[k].y);
          grid[pointlist[k].x][pointlist[k].y] = 1;
          drawCrystal();
          pointlist[k].x = bottomX[k];
          pointlist[k].y = bottomY;
        } else if (grid[pointlist[k].x][pointlist[k].y + 1] != 0)
        {
          System.out.println(step);
          //System.out.println("x= " + pointlist[k].x + ", y= " + pointlist[k].y);
          grid[pointlist[k].x][pointlist[k].y] = 1;
          drawCrystal();
          pointlist[k].x = bottomX[k];
          pointlist[k].y = bottomY;
        } else if (grid[pointlist[k].x][pointlist[k].y - 1] != 0)
        {
          System.out.println(step);
          //System.out.println("x= " + pointlist[k].x + ", y= " + pointlist[k].y);
          grid[pointlist[k].x][pointlist[k].y] = 1;
          drawCrystal();
          pointlist[k].x = bottomX[k];
          pointlist[k].y = bottomY;
        } else if (grid[pointlist[k].x - 1][pointlist[k].y + 1] != 0)
        {
          System.out.println(step);
          //System.out.println("x= " + pointlist[k].x + ", y= " + pointlist[k].y);
          grid[pointlist[k].x][pointlist[k].y] = 1;
          drawCrystal();
          pointlist[k].x = bottomX[k];
          pointlist[k].y = bottomY;
        } else if (grid[pointlist[k].x + 1][pointlist[k].y - 1] != 0)
        {
          System.out.println(step);
          //System.out.println("x= " + pointlist[k].x + ", y= " + pointlist[k].y);
          grid[pointlist[k].x][pointlist[k].y] = 1;
          drawCrystal();
          pointlist[k].x = bottomX[k];
          pointlist[k].y = bottomY;
        } else if (grid[pointlist[k].x + 1][pointlist[k].y + 1] != 0)
        {
          System.out.println(step);
          //System.out.println("x= " + pointlist[k].x + ", y= " + pointlist[k].y);
          grid[pointlist[k].x][pointlist[k].y] = 1;
          drawCrystal();
          pointlist[k].x = bottomX[k];
          pointlist[k].y = bottomY;
        } else if (grid[pointlist[k].x - 1][pointlist[k].y - 1] != 0)
        {
          System.out.println(step);
          //System.out.println("x= " + pointlist[k].x + ", y= " + pointlist[k].y);
          grid[pointlist[k].x][pointlist[k].y] = 1;
          drawCrystal();
          pointlist[k].x = bottomX[k];
          pointlist[k].y = bottomY;
        }else if (grid[pointlist[k].x][pointlist[k].y] != 0)
        {
          System.out.println(step);
          //System.out.println("x= " + pointlist[k].x + ", y= " + pointlist[k].y);
          grid[pointlist[k].x][pointlist[k].y] = 1;
          drawCrystal();
          pointlist[k].x = bottomX[k];
          pointlist[k].y = bottomY;
        }
        if (pointlist[k].x == centerX && pointlist[k].y == centerY)
        {
          System.out.println(step);
          //System.out.println("x= " + pointlist[k].x + ", y= " + pointlist[k].y);
          grid[pointlist[k].x][pointlist[k].y] = 1;
          pointlist[k].x = bottomX[k];
          pointlist[k].y = bottomY;
          //stop();
          //break;
        }
        /*
        for (int l=0; l<DRAW_WIDTH;l++){
          for (int j=0; j<DRAW_HEIGHT;j++){
           if (grid[l][j] == 1){
             pixelWriter.setColor(l, j,Color.BLUE);
           }
          }
        }
        */
        double r = random.nextDouble();
        if (r < 0.25)
        {
          pointlist[k].y -= 1;
        } else if (r < 0.5)
        {
          pointlist[k].y += 1;
        } else if (r < 0.75)
        {
          pointlist[k].x += 1;
        } else
        {
          pointlist[k].x -= 1;
        }
        pixelWriter.setColor(pointlist[k].x, pointlist[k].y, Color.WHITE);
      }

    }
  }

  private void drawCrystal()
  {

    for (int l = 0; l < DRAW_WIDTH; l++)
    {
      for (int j = 0; j < DRAW_HEIGHT; j++)
      {
        int neighbors = 0;
        if (grid[l][j] == 1)
        {
          if (grid[l + 1][j] == 1)
          {
            neighbors++;
          }
          if (grid[l][j + 1] == 1)
          {
            neighbors++;
          }
          if (grid[l + 1][j + 1] == 1)
          {
            neighbors++;
          }
          if (grid[l][j - 1] == 1)
          {
            neighbors++;
          }
          if (grid[l - 1][j] == 1)
          {
            neighbors++;
          }
          if (grid[l - 1][j + 1] == 1)
          {
            neighbors++;
          }
          if (grid[l + 1][j - 1] == 1)
          {
            neighbors++;
          }
          if (grid[l - 1][j - 1] == 1)
          {
            neighbors++;
          }
          if (neighbors == 0)
          {
            pixelWriter.setColor(l, j, Color.LIGHTBLUE);
          } else if (neighbors == 1)
          {
            pixelWriter.setColor(l, j, Color.CYAN);
          } else if (neighbors == 2)
          {
            pixelWriter.setColor(l, j, Color.DARKCYAN);
          } else if (neighbors == 3)
          {
            pixelWriter.setColor(l, j, Color.BLUE);
          } else if (neighbors == 4)
          {
            pixelWriter.setColor(l, j, Color.BLUEVIOLET);
          } else if (neighbors == 5)
          {
            pixelWriter.setColor(l, j, Color.VIOLET);
          } else if (neighbors == 6)
          {
            pixelWriter.setColor(l, j, Color.DEEPPINK);
          } else if (neighbors == 7)
          {
            pixelWriter.setColor(l, j, Color.CRIMSON);
          } else if (neighbors == 8)
          {
            pixelWriter.setColor(l, j, Color.RED);
          }
        }


      }
    }
  }

  private void restart()
  {

  }

  //===================================================================================
  //   Point() is a simple data class with public fields and no methods.
  //===================================================================================
  class Point
  {
    public int x, y;

    public Point(int x, int y)
    {
      this.x = x;
      this.y = y;
      //this.y = DRAW_HEIGHT-1;
    }
  }

}
